Index: /palm/trunk/SOURCE/singleton_mod.f90
===================================================================
--- /palm/trunk/SOURCE/singleton_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/singleton_mod.f90	(revision 4591)
@@ -1,15 +1,36 @@
 !> @file singleton_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2020 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------------------------!
+!
+!
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! File re-formatted to follow the PALM coding standard
+!
+!
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 3761 2019-02-25 15:31:42Z raasch
-! statement added to prevent compiler warning about unused variables
+! Statement added to prevent compiler warning about unused variables
 !
 ! Revision 1.1  2002/05/02 18:56:59  raasch
@@ -17,22 +38,20 @@
 !
 !
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Multivariate Fast Fourier Transform
 !>
-!> Fortran 90 Implementation of Singleton's mixed-radix algorithm,
-!> RC Singleton, Stanford Research Institute, Sept. 1968.
-!>
-!> Adapted from fftn.c, translated from Fortran 66 to C by Mark Olesen and
-!> John Beale.
-!>
-!> Fourier transforms can be computed either in place, using assumed size
-!> arguments, or by generic function, using assumed shape arguments.
-!>
+!> Fortran 90 Implementation of Singleton's mixed-radix algorithm, RC Singleton, Stanford Research
+!> Institute, Sept. 1968.
+!>
+!> Adapted from fftn.c, translated from Fortran 66 to C by Mark Olesen and John Beale.
+!>
+!> Fourier transforms can be computed either in place, using assumed size arguments, or by generic
+!> function, using assumed shape arguments.
 !>
 !> Public:
 !>
-!>   fftkind                              kind parameter of complex arguments
-!>                                        and function results.
+!>   fftkind                              kind parameter of complex arguments and function results.
 !>
 !>   fft(array, dim, inv, stat)           generic transform function
@@ -52,47 +71,39 @@
 !> Formal Parameters:
 !>
-!>   array    The complex array to be transformed. array can be of arbitrary
-!>            rank (i.e. up to seven).
-!>
-!>   shape    With subroutine fftn, the shape of the array to be transformed
-!>            has to be passed separately, since fftradix - the internal trans-
-!>            formation routine - will treat array always as one dimensional.
-!>            The product of elements in shape must be the number of
+!>   array    The complex array to be transformed. Array can be of arbitrary rank (i.e. up to seven).
+!>
+!>   shape    With subroutine fftn, the shape of the array to be transformed has to be passed
+!>            separately, since fftradix - the internal transformation routine - will always treat
+!>            array as one dimensional. The product of elements in shape must be the number of
 !>            elements in array.
-!>            Although passing array with assumed shape would have been nicer,
-!>            I prefered assumed size in order to prevent the compiler from
-!>            using a copy-in-copy-out mechanism. That would generally be
-!>            necessary with fftn passing array to fftradix and with fftn
-!>            being prepared for accepting non consecutive array sections.
-!>            Using assumed size, it's up to the user to pass an array argu-
-!>            ment, that can be addressed as continous one dimensional array
-!>            without copying. Otherwise, transformation will not really be
-!>            performed in place.
-!>            On the other hand, since the rank of array and the size of
-!>            shape needn't match, fftn is appropriate for handling more than
-!>            seven dimensions.
-!>            As far as function fft is concerned all this doesn't matter,
-!>            because the argument will be copied anyway. Thus no extra
-!>            shape argument is needed for fft.
+!>            Although passing array with assumed shape would have been nicer, I prefered assumed
+!>            size in order to prevent the compiler from using a copy-in-copy-out mechanism. That
+!>            would generally be necessary with fftn passing array to fftradix and with fftn being
+!>            prepared for accepting non consecutive array sections. Using assumed size, it's up to
+!>            the user to pass an array argument, that can be addressed as continous one dimensional
+!>            array without copying. Otherwise, transformation will not really be performed in place.
+!>            On the other hand, since the rank of array and the size of shape needn't match, fftn
+!>            is appropriate for handling more than seven dimensions. As far as function fft is
+!>            concerned all this doesn't matter, because the argument will be copied anyway. Thus no
+!>            extra shape argument is needed for fft.
 !>
 !> Optional Parameters:
 !>
-!>   dim      One dimensional integer array, containing the dimensions to be
-!>            transformed. Default is (/1,...,N/) with N being the rank of
-!>            array, i.e. complete transform. dim can restrict transformation
-!>            to a subset of available dimensions. Its size must not exceed the
-!>            rank of array or the size of shape respectivly.
-!>
-!>   inv      If .true., inverse transformation will be performed. Default is
-!>            .false., i.e. forward transformation.
-!>
-!>   stat     If present, a system dependent nonzero status value will be
-!>            returned in stat, if allocation of temporary storage failed.
+!>   dim      One dimensional integer array, containing the dimensions to be transformed. Default
+!>            is (/1,...,N/) with N being the rank of array, i.e. complete transform. dim can
+!>            restrict transformation to a subset of available dimensions. Its size must not exceed
+!>            the rank of array or the size of shape respectivly.
+!>
+!>   inv      If .true., inverse transformation will be performed. Default is .false., i.e. forward
+!>            transformation.
+!>
+!>   stat     If present, a system dependent nonzero status value will be returned in stat, if
+!>            allocation of temporary storage failed.
 !>
 !>
 !> Scaling:
 !>
-!>   Transformation results will always be scaled by the square root of the
-!>   product of sizes of each dimension in dim. (See examples below)
+!>   Transformation results will always be scaled by the square root of the product of sizes of each
+!>   dimension in dim. (See examples below)
 !>
 !>
@@ -111,6 +122,5 @@
 !>     result = fft(A, dim=(/1,3/))
 !>
-!>   will transform with respect to the first and the third dimension, scaled
-!>   by sqrt(L*N).
+!>   will transform with respect to the first and the third dimension, scaled by sqrt(L*N).
 !>
 !>     result = fft(fft(A), inv=.true.)
@@ -127,33 +137,29 @@
 !>
 !>   Following changes have been introduced with respect to fftn.c:
-!>   - complex arguments and results are of type complex, rather than
-!>     real an imaginary part separately.
-!>   - increment parameter (magnitude of isign) has been dropped,
-!>     inc is always one, direction of transform is given by inv.     
-!>   - maxf and maxp have been dropped. The amount of temporary storage
-!>     needed is determined by the fftradix routine. Both fftn and fft
-!>     can handle any size of array. (Maybe they take a lot of time and
-!>     memory, but they will do it)
-!>
-!>   Redesigning fftradix in a way, that it handles assumed shape arrays
-!>   would have been desirable. However, I found it rather hard to do this
-!>   in an efficient way. Problems were:
-!>   - to prevent stride multiplications when indexing arrays. At least our
-!>     compiler was not clever enough to discover that in fact additions
-!>     would do the job as well. On the other hand, I haven't been clever
-!>     enough to find an implementation using array operations.
-!>   - fftradix is rather large and different versions would be necessaray
-!>     for each possible rank of array.
-!>   Consequently, in place transformation still needs the argument stored
-!>   in a consecutive bunch of memory and can't be performed on array
-!>   sections like A(100:199:-3, 50:1020). Calling fftn with such sections
-!>   will most probably imply copy-in-copy-out. However, the function fft
-!>   works with everything it gets and should be convenient to use.
+!>   - Complex arguments and results are of type complex, rather than real an imaginary part
+!>     separately.
+!>   - Increment parameter (magnitude of isign) has been dropped, inc is always one, direction of
+!>     transform is given by inv.
+!>   - maxf and maxp have been dropped. The amount of temporary storage needed is determined by the
+!>     fftradix routine. Both fftn and fft can handle any size of array. (Maybe they take a lot of
+!>     time and memory, but they will do it)
+!>
+!>   Redesigning fftradix in a way, that it handles assumed shape arrays would have been desirable.
+!>   However, I found it rather hard to do this in an efficient way. Problems were:
+!>   - To prevent stride multiplications when indexing arrays. At least our compiler was not clever
+!>     enough to discover that in fact additions would do the job as well. On the other hand, I
+!>     haven't been clever enough to find an implementation using array operations.
+!>   - fftradix is rather large and different versions would be necessaray for each possible rank of
+!>     array.
+!>   Consequently, in place transformation still needs the argument stored in a consecutive bunch of
+!>   memory and can't be performed on array sections like A(100:199:-3, 50:1020). Calling fftn with
+!>   such sections will most probably imply copy-in-copy-out. However, the function fft works with
+!>   everything it gets and should be convenient to use.
 !>
 !> Michael Steffens, 09.12.96, <Michael.Steffens@mbox.muk.uni-hannover.de>
 !> Restructured fftradix for better optimization. M. Steffens, 4 June 1997
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE singleton
- 
+
 
     USE kinds
@@ -162,10 +168,11 @@
 
     PRIVATE
-    PUBLIC:: fft, fftn
-
-    REAL(wp), PARAMETER:: sin60 = 0.86602540378443865_wp
-    REAL(wp), PARAMETER:: cos72 = 0.30901699437494742_wp
-    REAL(wp), PARAMETER:: sin72 = 0.95105651629515357_wp
-    REAL(wp), PARAMETER:: pi    = 3.14159265358979323_wp
+    PUBLIC ::  fft   !<
+    PUBLIC ::  fftn  !<
+
+    REAL(wp), PARAMETER ::  cos72 = 0.30901699437494742_wp  !<
+    REAL(wp), PARAMETER ::  pi    = 3.14159265358979323_wp  !<
+    REAL(wp), PARAMETER ::  sin60 = 0.86602540378443865_wp  !<
+    REAL(wp), PARAMETER ::  sin72 = 0.95105651629515357_wp  !<
 
     INTERFACE fft
@@ -183,22 +190,22 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft1d(array, dim, inv, stat) RESULT(ft)
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft1d( array, dim, inv, stat ) RESULT( ft )
 !
 !-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:), INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),               INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                    INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp),  DIMENSION(:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:), INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),               INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                    INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Function result
-    COMPLEX(wp), DIMENSION(SIZE(array, 1)):: ft
-
-    INTEGER(iwp)::  idum
-    INTEGER(iwp)::  ishape(1)
+    COMPLEX(wp), DIMENSION(SIZE(array, 1)) ::  ft  !<
+
+    INTEGER(iwp) ::  idum       !<
+    INTEGER(iwp) ::  ishape(1)  !<
 
 !
@@ -208,5 +215,5 @@
     ft = array
     ishape = SHAPE( array )
-    CALL fftn(ft, ishape, inv = inv,  stat = stat)
+    CALL fftn( ft, ishape, inv = inv,  stat = stat )
 !
 !-- Next statement to prevent compiler warning about unused variable
@@ -216,21 +223,78 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft2d(array, dim, inv, stat) RESULT(ft)
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft2d( array, dim, inv, stat ) RESULT( ft )
 !
 !-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:,:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:),   INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                 INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                      INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp),  DIMENSION(:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:),   INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                 INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                      INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Function result
-    COMPLEX(wp), DIMENSION(SIZE(array, 1), SIZE(array, 2)):: ft
-
-    INTEGER(iwp) ::  ishape(2)
+    COMPLEX(wp), DIMENSION(SIZE(array, 1), SIZE(array, 2)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(2)  !<
+!
+!-- Intrinsics used
+    INTRINSIC SIZE, SHAPE
+
+    ft = array
+    ishape = SHAPE( array )
+    CALL fftn( ft, ishape, dim, inv, stat )
+
+ END FUNCTION fft2d
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing function description.
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft3d( array, dim, inv, stat ) RESULT( ft )
+!
+!-- Formal parameters
+    COMPLEX(wp),  DIMENSION(:,:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:),     INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                   INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                        INTENT(IN),  OPTIONAL ::  inv    !<
+!
+!-- Function result
+    COMPLEX(wp), DIMENSION(SIZE(array, 1), SIZE(array, 2), SIZE(array, 3)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(3)  !<
+
+!
+!-- Intrinsics used
+    INTRINSIC SIZE, SHAPE
+
+    ft = array
+    ishape = SHAPE( array)
+    CALL fftn(ft, ishape, dim, inv, stat)
+
+ END FUNCTION fft3d
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing function description.
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft4d( array, dim, inv, stat ) RESULT( ft )
+!
+!-- Formal parameters
+    COMPLEX(wp),  DIMENSION(:,:,:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:),       INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                     INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                          INTENT(IN),  OPTIONAL ::  inv    !<
+!
+!-- Function result
+    COMPLEX(wp), DIMENSION(SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(4)  !<
 !
 !-- Intrinsics used
@@ -241,55 +305,25 @@
     CALL fftn(ft, ishape, dim, inv, stat)
 
- END FUNCTION fft2d
-
-
-!------------------------------------------------------------------------------!
+ END FUNCTION fft4d
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft3d(array, dim, inv, stat) RESULT(ft)
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft5d( array, dim, inv, stat ) RESULT( ft )
 !
 !-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:,:,:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:),     INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                   INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                        INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp),  DIMENSION(:,:,:,:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:),         INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                       INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                            INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Function result
-    COMPLEX(wp), &
-         DIMENSION(SIZE(array, 1), SIZE(array, 2), SIZE(array, 3)):: ft
-
-    INTEGER(iwp) ::  ishape(3)
-
-!
-!-- Intrinsics used
-    INTRINSIC SIZE, SHAPE
-
-    ft = array
-    ishape = SHAPE( array)
-    CALL fftn(ft, ishape, dim, inv, stat)
-
- END FUNCTION fft3d
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft4d(array, dim, inv, stat) RESULT(ft)
-!
-!-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:,:,:,:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:),       INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                     INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                          INTENT(IN),  OPTIONAL:: inv
-!
-!-- Function result
-    COMPLEX(wp), DIMENSION( &
-         SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4)):: ft
-
-    INTEGER(iwp) ::  ishape(4)
+    COMPLEX(wp), DIMENSION(SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4), SIZE(array, 5)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(5)  !<
+
 !
 !-- Intrinsics used
@@ -300,26 +334,25 @@
     CALL fftn(ft, ishape, dim, inv, stat)
 
- END FUNCTION fft4d
-
-
-!------------------------------------------------------------------------------!
+ END FUNCTION fft5d
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft5d(array, dim, inv, stat) RESULT(ft)
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft6d( array, dim, inv, stat ) RESULT( ft )
 !
 !-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:,:,:,:,:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:),         INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                       INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                            INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp),  DIMENSION(:,:,:,:,:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp), DIMENSION(:),           INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                         INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                              INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Function result
-    COMPLEX(wp), DIMENSION( &
-         SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4), &
-         SIZE(array, 5)):: ft
-
-    INTEGER(iwp) ::  ishape(5)
+    COMPLEX(wp), DIMENSION( SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4),        &
+                            SIZE(array, 5), SIZE(array, 6)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(6)  !<
 
 !
@@ -331,26 +364,25 @@
     CALL fftn(ft, ishape, dim, inv, stat)
 
- END FUNCTION fft5d
-
-
-!------------------------------------------------------------------------------!
+ END FUNCTION fft6d
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft6d(array, dim, inv, stat) RESULT(ft)
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION fft7d( array, dim, inv, stat ) RESULT( ft )
 !
 !-- Formal parameters
-    COMPLEX(wp),  DIMENSION(:,:,:,:,:,:), INTENT(IN)           :: array
-    INTEGER(iwp), DIMENSION(:),           INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                         INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                              INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp), DIMENSION(:,:,:,:,:,:,:), INTENT(IN)            ::  array  !<
+    INTEGER(iwp),            DIMENSION(:), INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),                          INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                               INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Function result
-    COMPLEX(wp), DIMENSION( &
-         SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4), &
-         SIZE(array, 5), SIZE(array, 6)):: ft
-
-    INTEGER(iwp) ::  ishape(6)
+    COMPLEX(wp), DIMENSION( SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4),        &
+                            SIZE(array, 5), SIZE(array, 6), SIZE(array, 7)) ::  ft  !<
+
+    INTEGER(iwp) ::  ishape(7)  !<
 
 !
@@ -362,59 +394,28 @@
     CALL fftn(ft, ishape, dim, inv, stat)
 
- END FUNCTION fft6d
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> @todo Missing function description.
-!------------------------------------------------------------------------------!
- FUNCTION fft7d(array, dim, inv, stat) RESULT(ft)
+ END FUNCTION fft7d
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE fftn( array, shape, dim, inv, stat )
 !
 !-- Formal parameters
-    COMPLEX(wp), DIMENSION(:,:,:,:,:,:,:), INTENT(IN)           :: array
-    INTEGER(iwp),          DIMENSION(:),   INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),                          INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                               INTENT(IN),  OPTIONAL:: inv
-!
-!-- Function result
-    COMPLEX(wp), DIMENSION( &
-         SIZE(array, 1), SIZE(array, 2), SIZE(array, 3), SIZE(array, 4), &
-         SIZE(array, 5), SIZE(array, 6), SIZE(array, 7)):: ft
-
-    INTEGER(iwp) ::  ishape(7)
-
-!
-!-- Intrinsics used
-    INTRINSIC SIZE, SHAPE
-
-    ft = array
-    ishape = SHAPE( array )
-    CALL fftn(ft, ishape, dim, inv, stat)
-
- END FUNCTION fft7d
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
- SUBROUTINE fftn(array, shape, dim, inv, stat)
-!
-!-- Formal parameters
-    COMPLEX(wp),  DIMENSION(*), INTENT(INOUT)        :: array
-    INTEGER(iwp), DIMENSION(:), INTENT(IN)           :: shape
-    INTEGER(iwp), DIMENSION(:), INTENT(IN),  OPTIONAL:: dim
-    INTEGER(iwp),               INTENT(OUT), OPTIONAL:: stat
-    LOGICAL,                    INTENT(IN),  OPTIONAL:: inv
+    COMPLEX(wp),  DIMENSION(*), INTENT(INOUT)         ::  array  !<
+    INTEGER(iwp), DIMENSION(:), INTENT(IN)            ::  shape  !<
+    INTEGER(iwp), DIMENSION(:), INTENT(IN),  OPTIONAL ::  dim    !<
+    INTEGER(iwp),               INTENT(OUT), OPTIONAL ::  stat   !<
+    LOGICAL,                    INTENT(IN),  OPTIONAL ::  inv    !<
 !
 !-- Local arrays
-    INTEGER(iwp), DIMENSION(SIZE(shape)):: d
+    INTEGER(iwp), DIMENSION(SIZE(shape)) ::  d  !<
 !
 !-- Local scalars
-    LOGICAL      :: inverse
-    INTEGER(iwp) :: i, ndim, ntotal
-    REAL(wp):: scale
+    LOGICAL      ::  inverse          !<
+    INTEGER(iwp) ::  i, ndim, ntotal  !<
+    REAL(wp)     ::  scale            !<
 !
 !-- Intrinsics used
@@ -423,29 +424,27 @@
 !
 !-- Optional parameter settings
-    IF (PRESENT(inv)) THEN
+    IF ( PRESENT( inv ) )  THEN
        inverse = inv
     ELSE
        inverse = .FALSE.
     END IF
-    IF (PRESENT(dim)) THEN
-       ndim = MIN(SIZE(dim), SIZE(d))
-       d(1:ndim) = DIM(1:ndim)
+    IF ( PRESENT( dim ) )  THEN
+       ndim = MIN( SIZE( dim ), SIZE( d ) )
+       d(1:ndim) = DIM( 1:ndim )
     ELSE
-       ndim = SIZE(d)
-       d = (/(i, i = 1, SIZE(d))/)
+       ndim = SIZE( d )
+        d = (/( i, i = 1, SIZE( d ) )/)
     END IF
 
-    ntotal = PRODUCT(shape)
-    scale = SQRT(1.0_wp / PRODUCT(shape(d(1:ndim))))
-    DO i = 1, ntotal
-       array(i) = CMPLX(REAL(array(i)) * scale, AIMAG(array(i)) * scale, &
-            KIND=wp)
+    ntotal = PRODUCT( shape )
+    scale = SQRT( 1.0_wp / PRODUCT( shape( d(1:ndim) ) ) )
+    DO  i = 1, ntotal
+       array(i) = CMPLX( REAL( array(i) ) * scale, AIMAG( array(i) ) * scale, KIND = wp )
     END DO
 
-    DO i = 1, ndim
-       CALL fftradix(array, ntotal, shape(d(i)), PRODUCT(shape(1:d(i))), &
-            inverse, stat)
-       IF (PRESENT(stat)) THEN
-          IF (stat /=0) RETURN
+    DO  i = 1, ndim
+       CALL fftradix( array, ntotal, shape( d(i) ), PRODUCT( shape( 1:d(i) ) ), inverse, stat )
+       IF ( PRESENT( stat ) )  THEN
+          IF ( stat /= 0 )  RETURN
        END IF
     END DO
